<template>
  <div v-loading="isLoading" class="container mx-auto my-[37px]">
    <div v-if="allowCompany">
      <div
        :class="isProviderPromotion1 ? 'grid grid-cols-3 mx-auto h-fit gap-[16px] w-[1200px]' : ''"
      >
        <div
          v-for="promotion in promotions"
          :key="promotion.Id"
          :class="isProviderPromotion1 ? 'min-h-[380px]' : 'min-h-[230px]'"
        >
          <promotion-vertical-card
            :promotion="promotion"
            :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
            :authenticated="authenticated"
            :on-apply-promotion="onApplyPromotion"
            :is-processing="isProcessing"
            :is-applying="applyRequest.PromotionId === promotion.Id"
            :on-click-spin-now="onClickSpinNow"
            v-if="isProviderPromotion1"
            :validate-lucky-wheelbutton="validateLuckyWheelbutton(promotion)"
          />
          <promotion-horizontal-card
            :key="promotion.Id"
            :check-promotion-group="checkPromotionGroup"
            :is-hover-scale-center="true"
            :promotion="promotion"
            :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
            :authenticated="authenticated"
            :on-apply-promotion="onApplyPromotion"
            :is-processing="isProcessing"
            :is-applying="applyRequest.PromotionId === promotion.Id"
            :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
            :on-click-spin-now="onClickSpinNow"
            v-else
          />
        </div>
      </div>
    </div>
    <div v-else>
      <div
        class="grid grid-cols-3 mx-auto h-fit gap-[16px] w-[1200px]"
      >
        <div
          v-for="promotion in promotions"
          :key="promotion.Id"
          class="min-h-[380px]"
        >
          <promotion-vertical-card
            :promotion="promotion"
            :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
            :authenticated="authenticated"
            :on-apply-promotion="onApplyPromotion"
            :is-processing="isProcessing"
            :is-applying="applyRequest.PromotionId === promotion.Id"
            :on-click-spin-now="onClickSpinNow"
            :validate-lucky-wheelbutton="validateLuckyWheelbutton(promotion)"
          />
        </div>
      </div>
      <div
        v-if="promotions.length === 0"
        class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
      >
        <div class="text-4xl text-center truncate no-data text-ellipsis">
          {{ $t("no_promotion_info") }}
        </div>
        <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  setup() {
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      applyRequest,
      checkPromotionGroup,
      isProviderPromotion1,
      allowCompany,
      isMain,
      onClickSpinNow,
      validateLuckyWheelbutton,
    } = usePromotion();
    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      applyRequest,
      checkPromotionGroup,
      isProviderPromotion1,
      allowCompany,
      isMain,
      onClickSpinNow,
      validateLuckyWheelbutton,
    };
  },
});
</script>
